#ifndef ADC_5V_Display_h
#define ADC_5V_Display_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class ADC_5V_Display : public pfodControl {
  public:
    ADC_5V_Display(pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void setBase(int c, int r);
    void setBaseScaling(double _scaling);
    void setValue(int newValue);
    void skipUpdate();

  private:
    void fullUpdate();
    boolean haveStateChange();
    void saveCurrentState();
    int baseCol;
    int baseRow;
    float baseScaling;
    int z_idx;
    int previousValue; // for update
    boolean skip_Update;
};
#endif // ADC_5V_Display_h





