#include "Uno_board.h"
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This generated code may be freely used for both private and commercial use
   provided this copyright is maintained.
*/

// dimensions in 1/10"
// 19 x 24 pin dims, but use 22 height
Uno_board::Uno_board(pfodDwgs *_dwgsPtr)  : pfodControl(_dwgsPtr)  {
  z_idx = pfodDwgs::reserveIdx(1); // LED indicator
  ledOn = 0;
}

void Uno_board::setLed(byte on) {
  ledOn = on;
}

void Uno_board::setBase(int c, int r) {
  baseCol = c;
  baseRow = r;
}

int Uno_board::getBaseCol() {
  return baseCol;
}

int Uno_board::getBaseRow() {
  return baseRow;
}


void Uno_board::drawFirst() {
  dwgsPtr->pushZero(baseCol, baseRow);
}

void Uno_board::drawLast() {
  update(); // update with current state
  dwgsPtr->popZero(); // undo move
}

void Uno_board::drawPins() {

  dwgsPtr->pushZero(0, boardRows);
  int i = 0;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("RX\u2190")).bold().fontSize(-10).offset(boardCols - 2.75f,  - (i * 1)).send();
  i = 1;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("TX\u2192")).bold().fontSize(-10).offset(boardCols - 3,  - (i * 1)).send();
  dwgsPtr->pushZero(boardCols - 0.25, -8.0);
  for (i = 6; i < 10; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.5 - (i * 1)).send();
  }
  dwgsPtr->pushZero(-1.25, 0);
  i = 6;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(0,  - (i * 1) - 0.25f).send();
  i = 7;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("AREF")).bold().fontSize(-10).offset(0,  - (i * 1) - 0.25f).send();
  i = 8;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("SDA")).bold().fontSize(-10).offset(0,  - (i * 1) - 0.25f).send();
  i = 9;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("SCL")).bold().fontSize(-10).offset(0, - (i * 1) - 0.25f).send();

  i = 5;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("LED")).bold().fontSize(-10).offset(-2.5, - (i * 1) - 0.25).send();
  dwgsPtr->pushZero(-1.25,  - (i * 1) - 0.25, 0.3);
  dwgsPtr->rectangle().idx(z_idx).filled().color(dwgsPtr->WHITE).centered().send();
  dwgsPtr->popZero(); // undo move

  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move

  dwgsPtr->pushZero(0, -7);
  dwgsPtr->pushZero(-0.25, 0.0);
  for (i = 0; i < 8; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.25 - (i * 1)).send();
  }
  dwgsPtr->pushZero(0, 7);
  for (i = 0; i < 6; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.25 - (i * 1)).send();
  }
  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move
  i = 0;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("Vin")).bold().fontSize(-10).offset(1.3 ,  - (i * 1) ).send();
  i = 1;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(1.5 ,  - (i * 1) ).send();
  i = 2;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(1.5 ,  - (i * 1) ).send();
  i = 3;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("5V")).bold().fontSize(-10).offset(1.5 - 0.25 ,  - (i * 1) ).send();
  i = 4;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("3.3V")).bold().fontSize(-10).offset(1.5 + 0.1 ,  - (i * 1) ).send();
  i = 5;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("RESET")).bold().fontSize(-10).offset(1.5 + 0.6 ,  - (i * 1) ).send();
  i = 6;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("IOREF")).bold().fontSize(-10).offset(1.5 + 0.4 ,  - (i * 1) ).send();
  i = 7;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("ATN")).bold().fontSize(-10).offset(1.5 ,  - (i * 1) ).send();

  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move
}

void Uno_board::drawBasicOutline() {
  dwgsPtr->rectangle().filled().size(boardCols + 2, boardRows + 3.5).offset(-1, -1.5).color(26).send();

  dwgsPtr->pushZero(10, 13);
#ifdef ARDUINO_AVR_MEGA2560
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("MEGA")).fontSize(+2).send();
#else
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("UNO")).fontSize(+4).send();
#endif
  dwgsPtr->popZero();
}

void Uno_board::draw() {
  drawOutline();
}

void Uno_board::drawOutline() {
  dwgsPtr->rectangle().filled().size(boardCols + 2, boardRows + 3.5).offset(-1, -1.5).color(26).send();
  dwgsPtr->rectangle().filled().size(4.7, 6.3).offset(11.5 , -4).color(dwgsPtr->SILVER).send();
  dwgsPtr->rectangle().filled().size(3.5, 5.3).offset(0.5,  - 2.5).color(dwgsPtr->BLACK).send();


  dwgsPtr->pushZero(18.5,  1.15);
  dwgsPtr->rectangle().filled().size(2.3, 2.3).centered().color(dwgsPtr->SILVER).send();
  dwgsPtr->circle().filled().radius(0.65).color(dwgsPtr->RED).send();
  dwgsPtr->popZero();

  dwgsPtr->pushZero(10, 13);
#ifdef ARDUINO_AVR_MEGA2560
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("MEGA")).fontSize(+2).send();
#else
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("UNO")).fontSize(+4).send();
#endif
  dwgsPtr->popZero();

}

void Uno_board::update() {
  if (ledOn) {
    dwgsPtr->rectangle().idx(z_idx).filled().color(118).centered().send();
  } else {
    dwgsPtr->rectangle().idx(z_idx).filled().color(dwgsPtr->WHITE).centered().send();
  }
}

